import os
import sys
import os
import arcpy

myScripts = os.path.join(os.path.dirname(__file__), "Scripts_lan")
sys.path.append(myScripts)

from tcomppansh_2d13 import CompositPansharp
from tradianceatmcor_4 import RadianceAtmcor
from treflectanceatmcor_4c import ReflectanceAtmcor
from tstecor_13b import SurfaceTemperature
from segment_2j import Segmentation

class Toolbox(object):
    def __init__(self):
        """Define the toolbox (the  name of the toolbox is the name of the
        .pyt file)."""
        self.label = "Landsat8"
        self.alias = "l8"

        # List of tool classes associated with this toolbox
        self.tools = [RadianceAtmcor,ReflectanceAtmcor,SurfaceTemperature,CompositPansharp,Segmentation]
