import arcpy
from arcpy import env

class ClassByAtr(object):
    """Classify by attributes ."""
    def __init__(self):
        self.label = "Classify by attributes"
        self.description =  ("Classify objects by their attributes")
        self.canRunInBackground = False
    def getParameterInfo(self):
        """Define the tool parameters."""
##        # Input parameter
##        in_dirr = arcpy.Parameter(
##            displayName="Workspace",
##            name="in_dirr",
##            datatype="DEWorkspace",
##            parameterType="Required",
##            direction="Input")
        # Input parameter
        in_shp = arcpy.Parameter(
            displayName="Segments shapefile  (.shp)",
            name="in_shp",
            datatype="GPTableView",
            parameterType="Required",
            direction="Input")
        # Input parameter
        s_pole = arcpy.Parameter(
            displayName="Field  to assign class",
            name="s_pole",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        s_pole.filter.list = ['Short', 'Long']
        s_pole.parameterDependencies = [in_shp.name]
        # Input parameter
        class_2 = arcpy.Parameter(
            displayName="Class value to assign",
            name="class_2",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        # Input parameter
        in_sql = arcpy.Parameter(
            displayName="SQL expression",
            name="in_sql",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        # Output parameter
        out_shp = arcpy.Parameter(
            displayName="Output segments shapefile  (.shp)",
            name="out_shp",
            datatype="DEShapefile",
            parameterType="Derived",
            direction="Output")
        out_shp.parameterDependencies=[in_shp.name]
        out_shp.schema.clone = True
      

        parameters=[in_shp,s_pole,class_2,in_sql,out_shp]
        return parameters
    def updateParameters(self, parameters):
        """Modify the values and properties of parameters before internal
        validation is performed.  This method is called whenever a parameter
        has been changed."""
        return

    def updateMessages(self, parameters):
        """Modify the messages created by internal validation for each tool
        parameter.  This method is called after internal validation."""
        return
    def execute(self, parameters, messages):





       
        in_poly=parameters[0].valueAsText   # data
        class_pole=parameters[1].valueAsText   # data
        class_value=parameters[2].value   # data
        where_sql=parameters[3].valueAsText   # data
        #out_poly=parameters[4].valueAsText   # data


##        wspace="D:\\LANDSAT8\\GEOBIA1\\"
##        in_poly="klasy5cc1_cc.shp"
##        class_pole="test"
##        class_value="3"
##        where_sql='"SLOPE">5'


        #env.workspace=wspace

        arcpy.MakeFeatureLayer_management(in_poly, "lyr2")
        arcpy.SelectLayerByAttribute_management("lyr2", "NEW_SELECTION", where_sql)
        arcpy.CalculateField_management("lyr2", class_pole, class_value, "PYTHON_9.3")
        arcpy.Delete_management("lyr2")
        #arcpy.Select_analysis(in_poly,out_poly)
