import arcpy
from arcpy import env
from arcpy.sa import*
from numpy import*


wspace=""    # katalog roboczy
in_poly=""
in_ras=""   # mapa klas
new_field=""

class ExtractRstat(object):
    """Zonal Statistics ."""
    def __init__(self):
        self.label = "Extract from raster"
        self.description =  ("Extract from raster object statistic")
        self.canRunInBackground = False
    def getParameterInfo(self):
        """Define the tool parameters."""
        # Input parameter
        in_dirr = arcpy.Parameter(
            displayName="Workspace",
            name="in_dirr",
            datatype="DEWorkspace",
            parameterType="Required",
            direction="Input")
        # Input parameter
        in_shp = arcpy.Parameter(
            displayName="Segments shapefile without path  (.shp)",
            name="in_shp",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        # Input parameter
        in_ras = arcpy.Parameter(
            displayName="Raster name without path (.tif)",
            name="in_ras",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        # Input parameter
        in_sss = arcpy.Parameter(
            displayName="Statistics : MEAN, STD, MAXIMUM, MINIMUM",
            name="in_sss",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        in_sss.value="MEAN"
        # Input parameter
        in_pole = arcpy.Parameter(
            displayName="New field with statistics",
            name="in_pole",
            datatype="GPString",
            parameterType="Required",
            direction="Input")


        parameters=[in_dirr,in_shp,in_ras,in_sss,in_pole]
        return parameters
    def updateParameters(self, parameters):
        """Modify the values and properties of parameters before internal
        validation is performed.  This method is called whenever a parameter
        has been changed."""
        return

    def updateMessages(self, parameters):
        """Modify the messages created by internal validation for each tool
        parameter.  This method is called after internal validation."""
        return
    def execute(self, parameters, messages):





        wspace=parameters[0].valueAsText    # katalog roboczy      
        in_poly=parameters[1].valueAsText   # data
        in_ras=parameters[2].valueAsText   # data
        statf=parameters[3].valueAsText   # data
        new_field=parameters[4].valueAsText   # data


        statff=statf
        env.workspace=wspace
        if statf=="MAXIMUM":
            statff="MAX"
        if statf=="MINIMUM":
            statff="MIN"            







        env.overwriteOutput=True

        arcpy.PolygonToRaster_conversion(in_poly, "OBID", "rtemp.tif","","",7.5)
        arcpy.BuildRasterAttributeTable_management("rtemp.tif", "Overwrite")

        ZonalStatisticsAsTable("rtemp.tif", "Value", in_ras,"ttemp.dbf","DATA",statf)

        rr=Raster("rtemp.tif")
        rmax=int(rr.maximum)

                                        
        stab=zeros((rmax+1),float)


        with arcpy.da.SearchCursor("ttemp.dbf",["VALUE",statff]) as cur:
            for row in cur:
                i=row[0]
                stab[i]=row[1]
        del cur

##        ak=stab[0]
##        for i in range(1,rmax+1):
##            if stab[i]<0.00000000001:
##                stab[i]=ak
##            else:
##                ak=stab[i]

        arcpy.AddField_management(in_poly, new_field, "DOUBLE")

        with arcpy.da.UpdateCursor(in_poly,["OBID",new_field]) as cur:
            for row in cur:
                i=row[0]
                row[1]=stab[i]
                cur.updateRow(row)
                
        del cur

        arcpy.Delete_management("rtemp.tif")
        arcpy.Delete_management("ttemp.dbf")
                
        
        
        

