import arcpy
from arcpy import env

class ClassLocatedNear(object):
    """Located Near ."""
    def __init__(self):
        self.label = "Classify located nearby"
        self.description =  ("Classify objects located nearby source objects")
        self.canRunInBackground = False
    def getParameterInfo(self):
        """Define the tool parameters."""
##        # Input parameter
##        in_dirr = arcpy.Parameter(
##            displayName="Workspace",
##            name="in_dirr",
##            datatype="DEWorkspace",
##            parameterType="Required",
##            direction="Input")
        # Input parameter
        in_shp = arcpy.Parameter(
            displayName="Segments shapefile  (.shp)",
            name="in_shp",
            datatype="GPTableView",
            parameterType="Required",
            direction="Input")
        # Input parameter
        s_pole = arcpy.Parameter(
            displayName="Field of classes for source objects",
            name="s_pole",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        s_pole.filter.list = ['Short', 'Long']
        s_pole.parameterDependencies = [in_shp.name]
        # Input parameter
        s_class = arcpy.Parameter(
            displayName="Class value of source objects",
            name="s_class",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        # Input parameter
        out_pole = arcpy.Parameter(
            displayName="Field to assign class",
            name="out_pole",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        out_pole.filter.list = ['Short', 'Long']
        out_pole.parameterDependencies = [in_shp.name]
        # Input parameter
        class_2 = arcpy.Parameter(
            displayName="Class value to assign",
            name="class_2",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        # Input parameter
        in_dyst = arcpy.Parameter(
            displayName="Distance [m]",
            name="in_dyst",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        
        # Output parameter
        out_shp = arcpy.Parameter(
            displayName="Segments shapefile  (.shp)",
            name="out_shp",
            datatype="DEShapefile",
            parameterType="Required",
            direction="Output")

        parameters=[in_shp,s_pole,s_class,out_pole,class_2,in_dyst,out_shp]
        return parameters
    def updateParameters(self, parameters):
        """Modify the values and properties of parameters before internal
        validation is performed.  This method is called whenever a parameter
        has been changed."""
        return

    def updateMessages(self, parameters):
        """Modify the messages created by internal validation for each tool
        parameter.  This method is called after internal validation."""
        return
    def execute(self, parameters, messages):





        #wspace=parameters[0].valueAsText    # katalog roboczy      
        in_poly=parameters[0].valueAsText   # data
        spole=parameters[1].valueAsText   # data
        sclass=parameters[2].value   # data
        outpole=parameters[3].valueAsText   # data
        class2=parameters[4].value   # data
        dyst=parameters[5].value
        out_poly=parameters[6].valueAsText


        #wspace="D:\\LANDSAT8\\GEOBIA1\\"
        ##in_poly="klasy5cc1_MergeObjects1.shp"
        ##spole="class1"
        ##sclass=1
        ##outpole="class2"
        ##class2=2
        ##dyst=1
        ##out_poly="klasy5cc1_MergeObjects3.shp"

        #env.workspace=wspace
        # dwa zbiory source i reszta
        where_clause='"'+spole+'"='+str(sclass)
        arcpy.Select_analysis(in_poly, "t1.shp", where_clause)
        where_clause='"'+spole+'"<>'+str(sclass)
        arcpy.Select_analysis(in_poly, "t2.shp", where_clause)


        arcpy.MakeFeatureLayer_management("t2.shp", "t2.lyr")
        arcpy.SelectLayerByLocation_management('t2.lyr', 'WITHIN_A_DISTANCE', 't1.shp', dyst, "NEW_SELECTION")

        expr=str(class2)
        arcpy.CalculateField_management("t2.lyr", outpole, expr, "PYTHON_9.3") 
        arcpy.Merge_management(["t1.shp","t2.shp"],out_poly)

        arcpy.Delete_management("t1.shp")
        arcpy.Delete_management("t2.shp")
        arcpy.Delete_management("t2.lyr")




